function sequence(...handlers) {
  const length = handlers.length;
  if (!length) {
    const handler = (context, resolve) => {
      return resolve();
    };
    return handler;
  }
  return (context, resolve) => {
    return applyHandle(0, context);
    function applyHandle(i, handleContext) {
      const handle = handlers[i];
      return handle(handleContext, () => {
        if (i < length - 1) {
          return applyHandle(i + 1, handleContext);
        } else {
          return resolve();
        }
      });
    }
  };
}
export {
  sequence
};
